Allow rebase to run if upstream is completely merged
[git/git.git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
12
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
19
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
23
24 Example: git-rebase master~1 topic
25
26 A---B---C topic A'\''--B'\''--C'\'' topic
27 / --> /
28 D---E---F---G master D---E---F---G master
29 '
30
31 SUBDIRECTORY_OK=Yes
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
36
37 RESOLVEMSG="
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
41 "
42 unset newbase
43 strategy=recursive
44 do_merge=
45 dotest=$GIT_DIR/.dotest-merge
46 prec=4
47 verbose=
48 git_am_opt=
49
50 continue_merge () {
51 test -n "$prev_head" || die "prev_head must be defined"
52 test -d "$dotest" || die "$dotest directory does not exist"
53
54 unmerged=$(git ls-files -u)
55 if test -n "$unmerged"
56 then
57 echo "You still have unmerged paths in your index"
58 echo "did you forget to use git add?"
59 die "$RESOLVEMSG"
60 fi
61
62 if ! git diff-index --quiet HEAD
63 then
64 if ! git-commit -C "`cat $dotest/current`"
65 then
66 echo "Commit failed, please do not call \"git commit\""
67 echo "directly, but instead do one of the following: "
68 die "$RESOLVEMSG"
69 fi
70 printf "Committed: %0${prec}d" $msgnum
71 else
72 printf "Already applied: %0${prec}d" $msgnum
73 fi
74 echo ' '`git rev-list --pretty=oneline -1 HEAD | \
75 sed 's/^[a-f0-9]\+ //'`
76
77 prev_head=`git rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
80
81 # onto the next patch:
82 msgnum=$(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
84 }
85
86 call_merge () {
87 cmt="$(cat $dotest/cmt.$1)"
88 echo "$cmt" > "$dotest/current"
89 hd=$(git rev-parse --verify HEAD)
90 cmt_name=$(git symbolic-ref HEAD)
91 msgnum=$(cat $dotest/msgnum)
92 end=$(cat $dotest/end)
93 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
95 export GITHEAD_$cmt GITHEAD_$hd
96 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
97 rv=$?
98 case "$rv" in
99 0)
100 unset GITHEAD_$cmt GITHEAD_$hd
101 return
102 ;;
103 1)
104 test -d "$GIT_DIR/rr-cache" && git rerere
105 die "$RESOLVEMSG"
106 ;;
107 2)
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
109 die "$RESOLVEMSG"
110 ;;
111 *)
112 die "Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
114 ;;
115 esac
116 }
117
118 finish_rb_merge () {
119 rm -r "$dotest"
120 echo "All done."
121 }
122
123 is_interactive () {
124 test -f "$dotest"/interactive ||
125 while case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
126 do
127 shift
128 done && test -n "$1"
129 }
130
131 is_interactive "$@" && exec git-rebase--interactive "$@"
132
133 while case "$#" in 0) break ;; esac
134 do
135 case "$1" in
136 --continue)
137 git diff-files --quiet || {
138 echo "You must edit all merge conflicts and then"
139 echo "mark them as resolved using git add"
140 exit 1
141 }
142 if test -d "$dotest"
143 then
144 prev_head="`cat $dotest/prev_head`"
145 end="`cat $dotest/end`"
146 msgnum="`cat $dotest/msgnum`"
147 onto="`cat $dotest/onto`"
148 continue_merge
149 while test "$msgnum" -le "$end"
150 do
151 call_merge "$msgnum"
152 continue_merge
153 done
154 finish_rb_merge
155 exit
156 fi
157 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
158 exit
159 ;;
160 --skip)
161 if test -d "$dotest"
162 then
163 if test -d "$GIT_DIR/rr-cache"
164 then
165 git rerere clear
166 fi
167 prev_head="`cat $dotest/prev_head`"
168 end="`cat $dotest/end`"
169 msgnum="`cat $dotest/msgnum`"
170 msgnum=$(($msgnum + 1))
171 onto="`cat $dotest/onto`"
172 while test "$msgnum" -le "$end"
173 do
174 call_merge "$msgnum"
175 continue_merge
176 done
177 finish_rb_merge
178 exit
179 fi
180 git am -3 --skip --resolvemsg="$RESOLVEMSG"
181 exit
182 ;;
183 --abort)
184 if test -d "$GIT_DIR/rr-cache"
185 then
186 git rerere clear
187 fi
188 if test -d "$dotest"
189 then
190 rm -r "$dotest"
191 elif test -d .dotest
192 then
193 rm -r .dotest
194 else
195 die "No rebase in progress?"
196 fi
197 git reset --hard ORIG_HEAD
198 exit
199 ;;
200 --onto)
201 test 2 -le "$#" || usage
202 newbase="$2"
203 shift
204 ;;
205 -M|-m|--m|--me|--mer|--merg|--merge)
206 do_merge=t
207 ;;
208 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
209 --strateg=*|--strategy=*|\
210 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
211 case "$#,$1" in
212 *,*=*)
213 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
214 1,*)
215 usage ;;
216 *)
217 strategy="$2"
218 shift ;;
219 esac
220 do_merge=t
221 ;;
222 -v|--verbose)
223 verbose=t
224 ;;
225 -C*)
226 git_am_opt=$1
227 shift
228 ;;
229 -*)
230 usage
231 ;;
232 *)
233 break
234 ;;
235 esac
236 shift
237 done
238
239 # Make sure we do not have .dotest
240 if test -z "$do_merge"
241 then
242 if mkdir .dotest
243 then
244 rmdir .dotest
245 else
246 echo >&2 '
247 It seems that I cannot create a .dotest directory, and I wonder if you
248 are in the middle of patch application or another rebase. If that is not
249 the case, please rm -fr .dotest and run me again. I am stopping in case
250 you still have something valuable there.'
251 exit 1
252 fi
253 else
254 if test -d "$dotest"
255 then
256 die "previous dotest directory $dotest still exists." \
257 'try git-rebase < --continue | --abort >'
258 fi
259 fi
260
261 # The tree must be really really clean.
262 git update-index --refresh || exit
263 diff=$(git diff-index --cached --name-status -r HEAD)
264 case "$diff" in
265 ?*) echo "cannot rebase: your index is not up-to-date"
266 echo "$diff"
267 exit 1
268 ;;
269 esac
270
271 # The upstream head must be given. Make sure it is valid.
272 upstream_name="$1"
273 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
274 die "invalid upstream $upstream_name"
275
276 # Make sure the branch to rebase onto is valid.
277 onto_name=${newbase-"$upstream_name"}
278 onto=$(git rev-parse --verify "${onto_name}^0") || exit
279
280 # If a hook exists, give it a chance to interrupt
281 if test -x "$GIT_DIR/hooks/pre-rebase"
282 then
283 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
284 echo >&2 "The pre-rebase hook refused to rebase."
285 exit 1
286 }
287 fi
288
289 # If the branch to rebase is given, first switch to it.
290 case "$#" in
291 2)
292 branch_name="$2"
293 git-checkout "$2" || usage
294 ;;
295 *)
296 if branch_name=`git symbolic-ref -q HEAD`
297 then
298 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
299 else
300 branch_name=HEAD ;# detached
301 fi
302 ;;
303 esac
304 branch=$(git rev-parse --verify "${branch_name}^0") || exit
305
306 # Now we are rebasing commits $upstream..$branch on top of $onto
307
308 # Check if we are already based on $onto with linear history,
309 # but this should be done only when upstream and onto are the same.
310 mb=$(git merge-base "$onto" "$branch")
311 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
312 # linear history?
313 ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
314 then
315 echo >&2 "Current branch $branch_name is up to date."
316 exit 0
317 fi
318
319 if test -n "$verbose"
320 then
321 echo "Changes from $mb to $onto:"
322 # We want color (if set), but no pager
323 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
324 fi
325
326 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
327 echo "First, rewinding head to replay your work on top of it..."
328 git-reset --hard "$onto"
329
330 # If the $onto is a proper descendant of the tip of the branch, then
331 # we just fast forwarded.
332 if test "$mb" = "$branch"
333 then
334 echo >&2 "Fast-forwarded $branch_name to $onto_name."
335 exit 0
336 fi
337
338 if test -z "$do_merge"
339 then
340 git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
341 git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
342 exit $?
343 fi
344
345 # start doing a rebase with git-merge
346 # this is rename-aware if the recursive (default) strategy is used
347
348 mkdir -p "$dotest"
349 echo "$onto" > "$dotest/onto"
350 echo "$onto_name" > "$dotest/onto_name"
351 prev_head=`git rev-parse HEAD^0`
352 echo "$prev_head" > "$dotest/prev_head"
353
354 msgnum=0
355 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
356 do
357 msgnum=$(($msgnum + 1))
358 echo "$cmt" > "$dotest/cmt.$msgnum"
359 done
360
361 echo 1 >"$dotest/msgnum"
362 echo $msgnum >"$dotest/end"
363
364 end=$msgnum
365 msgnum=1
366
367 while test "$msgnum" -le "$end"
368 do
369 call_merge "$msgnum"
370 continue_merge
371 done
372
373 finish_rb_merge